/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the LabelsData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LabelsData{}

// LabelsData struct for LabelsData
type LabelsData struct {
	Labels []string `json:"labels,omitempty"`
}

// NewLabelsData instantiates a new LabelsData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLabelsData() *LabelsData {
	this := LabelsData{}
	return &this
}

// NewLabelsDataWithDefaults instantiates a new LabelsData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLabelsDataWithDefaults() *LabelsData {
	this := LabelsData{}
	return &this
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *LabelsData) GetLabels() []string {
	if o == nil || IsNil(o.Labels) {
		var ret []string
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LabelsData) GetLabelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *LabelsData) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []string and assigns it to the Labels field.
func (o *LabelsData) SetLabels(v []string) {
	o.Labels = v
}

func (o LabelsData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LabelsData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	return toSerialize, nil
}

type NullableLabelsData struct {
	value *LabelsData
	isSet bool
}

func (v NullableLabelsData) Get() *LabelsData {
	return v.value
}

func (v *NullableLabelsData) Set(val *LabelsData) {
	v.value = val
	v.isSet = true
}

func (v NullableLabelsData) IsSet() bool {
	return v.isSet
}

func (v *NullableLabelsData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLabelsData(val *LabelsData) *NullableLabelsData {
	return &NullableLabelsData{value: val, isSet: true}
}

func (v NullableLabelsData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLabelsData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


